#include <stdio.h>
#include <stdlib.h>

#include "struct.hpp"
/* 
	FUNCION : leer_fichero;
	OBJETIVO : Leer la representacinm fuzzy de un sistema que esta almacenada
		en e fichero que se le para por parmetro
	PARAMETROS:
		name --> nombre del fichero
	FORMATO DEL FICHERO
		El formato del fichero ser:
			Nmero de vble
			POR CADA VBLE
				Nombre
				Tipo
				Mim
				Max
				Fichero
				Nmero de conjuntos  asociados a la vble
				POR CADA CNJ
					Nombre
					Tipo
					Left
					Right
					Top_left
					Top_right

			Nmero de Reglas
			POR CADA REGLA
			...

*/
char leer_fichero(char *name)
	{

	 extern vble *vble_entrada;
	 extern vble *vble_salida;
	 FILE *fd;
	 int n_vble;
	 int n_cnj;
	 int i,j;
	 int n_reglas;
	 vble *v,*pv;
	 cnj_fuzzy *c,*pc;

	 fd = fopen(name,"r");
	 if ( fd == NULL)
		{
		 perror("ERROR al abrir el fichero");
		 return (0);
		}

	 fscanf(fd,"%i",&n_vble);
	 for ( i = 0; i < n_vble; i ++)
		{
		 v = ( vble *) malloc(sizeof(vble));
		 if ( v == NULL)
			{
			 printf("\nERROR : Memoria Insufuciente");
			 exit(-1);
			}
		 fscanf(fd,"%s",v->nombre);
		 fscanf(fd,"%c",&v->tipo);
		 fscanf(fd,"%c",&v->tipo);
		 fgetc(fd);
		 fscanf(fd,"%lf",&v->min);
		 fscanf(fd,"%lf",&v->max);
		 fscanf(fd,"%s",v->fichero);
		 v->conjuntos = NULL;
		 v->next = NULL;
		 fscanf(fd,"%i",&n_cnj);
		 for ( j = 0; j < n_cnj; j ++)
			{
			 c = ( cnj_fuzzy *) malloc(sizeof(cnj_fuzzy));
			 if ( c == NULL)
				{
				 printf("\nERROR : Memoria Insufuciente");
				 exit(-1);
				}
			 fscanf(fd,"%s",c->nombre);
			 fscanf(fd,"%c",&c->tipo);
			 fscanf(fd,"%lf",&c->left);
			 fscanf(fd,"%lf",&c->right);
			 fscanf(fd,"%lf",&c->top_left);
			 fscanf(fd,"%lf",&c->top_right);
			 c->ptr_lista = NULL;
			 c->next = c->last = NULL;
			 if ( v->conjuntos == NULL)
				{ /* primer cnj*/
				 v->conjuntos = c;
				}
			 else
			  {
				pc =  v->conjuntos;
				while ( pc->next != NULL)
					pc = pc->next;
				pc->next = c;
				c->last =  pc;
			  }
			}
		 if ( v->tipo == ENTRADA)
			{
			 if (vble_entrada == NULL)
				{
				 vble_entrada = v;
				}
			 else
				{
				 pv = vble_entrada;
				 while ( pv -> next != NULL)
					pv = pv->next;
				 pv ->next = v;
				}       
			}
		 else
			{
			 if (vble_salida == NULL)
				{
				 vble_salida = v;
				}
			 else
				{
				 pv = vble_salida;
				 while ( pv -> next != NULL)
					pv = pv->next;
				 pv ->next = v;
				}
			}
		}
	}
